Subject: Re: bug#50594: 28.0.50; tramp error after upgrading sudo to version 1.9.8: option passprompt_override does not take a value

From: Joseph Mingrone <[email-masked]>
Date: Wed, 15 Sep 2021 07:41:29 -0300

On Wed, 2021-09-15 at 11:21, Michael Albinus <[email-masked]> wrote:

> Joseph Mingrone <[email-masked]> writes:

> Hi Joseph,

>> Recipe to reproduce the problem:

>> emacs -Q and evaluate
>>       (find-file "/sudo::/some/file")

>> Tramp runs
>>       sudo -u root -s -H -p P""a""s""s""w""o""r""d"": /bin/sh -i

>> but this error is now reported after upgrading sudo to 1.9.8

>>     sudo: (null): option "passprompt_override" does not take a value
>>     sudo: error initializing audit plugin sudoers_audit.

>> I guess this is related to the 2017-07-21 entry at
>> https://www.sudo.ws/changes.html.

>> Am I missing anything?

> Don't know. The ChangeLog entry you quote is four years old, I would
> expect the change is distributed already with recent sudo packages. Do
> you know which sudo version was installed before you have upgraded?

> Does the same error also happen when you call from a shell

> # sudo -u root -s -H -p P""a""s""s""w""o""r""d"": /bin/sh -i

> What happens if you call

> # sudo -u root -s -H /bin/sh -i

> I run Fedora 34, which uses sudo-1.9.5p2-1.fc34. And the upcoming Fedora
> 35 will offer sudo-1.9.7p2-2.fc35, so I have no chance to test with sudo
> 1.9.8 next time.

> Does it help to call

> # env SUDO_PROMPT=P""a""s""s""w""o""r""d"": sudo -u root -s -H /bin/sh -i

> Best regards, Michael.

Hi Michael,

Oops.  I misread the date of the ChangeLog entry and thought it was from
this year.  There are two mentions of password and prompt in the changes
between the last version that was in the FreeBSD ports tree, 1.9.7p2,
and version 1.9.8.

https://cgit.freebsd.org/ports/commit/security/sudo/Makefile?id=c403b7871cf09f123de4151bb77e8438f342075ep

sudo 1.9.7p2:

jrm@phe ~ % sudo -u root -s -H -p P""a""s""s""w""o""r""d"": /bin/sh -i
Password:
# whoami
root

sudo 1.9.8:

jrm@phe ~ % sudo -u root -s -H -p P""a""s""s""w""o""r""d"": /bin/sh -i
sudo: (null): option "passprompt_override" does not take a value
sudo: error initializing audit plugin sudoers_audit

jrm@phe ~ % sudo -u root -s -H /bin/sh -i
Password:
# whoami
root
#

jrm@phe ~ % env SUDO_PROMPT=P""a""s""s""w""o""r""d"": sudo -u root -s -H /bin/sh -i
Password:
# whoami
root

Joseph